﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using AsReaderP51N_Demo_Tool;


namespace AsReaderP31N_Demo_Tool
{
    public partial class frmFirmwareUpdate : Form
    {
        public frmFirmwareUpdate()
        {
            InitializeComponent();
        }


        private string getfile()
        {
            string file = string.Empty;
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Multiselect = true;
            dialog.Title = "打开";
            dialog.Filter = "Hex files(*.hex)|*.hex";
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (!string.IsNullOrEmpty(dialog.FileName))
                {
                    file = dialog.FileName;
                    bool successed = Device.UpdateLoadHex();
                    if (successed)
                    {
                        //MessageBox.Show("Hex load successed!");
                    }
                    else
                    {
                        MessageBox.Show("Hex load error!");
                        file = string.Empty;
                    }
                    //var autofile = File.ReadAllText(file, Encoding.UTF8);

                }
                else
                {
                    MessageBox.Show("No files.");
                }
            }
            return file;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //getfile
            this.progressBar1.Value = 0;
            this.textBox1.Text = getfile();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //update
            MessageBox.Show("Bootloader activated");

            this.Devmes.Clear();

            string hextext = File.ReadAllText(this.textBox1.Text, Encoding.UTF8);
            string[] sArray = hextext.Split(':');

            this.progressBar1.Maximum = sArray.Length;
            this.progressBar1.Value = 0;
            this.progressBar1.Step = 1;

            for (int i = 2; i < sArray.Length - 2; i++)
            {
                this.progressBar1.Value += this.progressBar1.Step;

                bool successed = Device.UpdateFirmware(sArray[i]);
                if (successed)
                {
                    //this.Devmes.AppendText(sArray[i]);

                    this.textBox1.Text = string.Empty;

                    //int bytemsg = sArray[i].Length / 2;
                    //string[] strArray = new string[bytemsg];
                    //for (int j = 0; j < (bytemsg); j++)
                    //{
                    //    strArray[j] = sArray[i].Substring(2 * j, 2);
                    //    //this.Devmes.AppendText(strArray[j]);
                    //    //this.Devmes.AppendText("  ");
                    //}
                }
                else
                {
                    MessageBox.Show("Hex load error!");
                    return;
                }
            }
            MessageBox.Show("Update complete...Please reset your hardware");
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(this.textBox1.Text))
            {
                this.button1.Enabled = false;
            }
            else
            {
                this.button1.Enabled = true;
            }
        }
    }
}
